#!/usr/bin/env python 
#file: array2d.py  
#mcs260s13,lowman
#2dim array example
"""
sample file data.txt
-------------
 2 3
 1.0 2.0 3.0
 4.0 5.0 6.0
-------------
first row of file contains two integers giving the number of 
rows and columns of the data (real numbers) that follow.

program:
1. read dimensions from first row of file 
2. read all data into a single string then converts to a 1-dim list
of floats.
3. copy 1-dim list into corresponding 2-dim list
4. find sum of all data, row sums, col sums
5. To stdout print a heading and a summary with data and sums.
"""


import heading
from sys import argv,exit
def open_file():
	if len(argv) == 1:
		print "no filename entered on the command line"
		exit(2)
	filename = argv[1]
	infid = open(filename,"r")
	return infid
def get_dim(infid):
	line = infid.readline() #read dimensions: row,col
	line = line.split()
	line = [int(x) for x in line]
	return tuple(line)
def get_data1d(infid):
	data = infid.read(); # read data
	data = data.split()
	data = [float(x) for x in data] #data in 1-dim list
	return data
def copy_1d2d(row,col,data1dim):
	a = [[0.0 for j in range(col)] for i in range(row)] #new 2-dim list
	k=0
	for i in range(row):
		for j in range(col):
			a[i][j] = data1dim[k]
			k += 1
	return a
def total(a,row,col):
	sum = 0;
	for i in range(row):
		for j in range(col):
			sum += a[i][j]
	return sum
def rowsum(a,row,col):
	rsum = [0.0 for i in range(row)]
	for i in range(row):
		sum = 0
		for j in range(col):
			sum += a[i][j]
		rsum[i] = sum
	return rsum	
def colsum(a,row,col):
	csum = [0.0 for j in range(col)]
	for j in range(col):
		sum = 0
		for i in range(row):
			sum += a[i][j]
		csum[j] = sum	
	return csum
def main():
	heading.heading()
	infid = open_file()
	row,col = get_dim(infid)
	print "row,col = ",row,col
	# input data as 1-dim list
	data1d = get_data1d(infid)
	infid.close()
	print "data-1dim: ",data1d
	#copy data in 1-dim list into 2-dim list a[][]
	a = copy_1d2d(row,col,data1d)
	print "a 2-dim: "
	for line in a:
		print line
	tot = total(a,row,col)
	print "tot: ",tot
	rsum = rowsum(a,row,col)
	csum = colsum(a,row,col)
	print "rowsum: ",rsum
	print "colsum: ",csum
	print "="*40
	i=0
	for r in a:
		print r, rsum[i]
		i+=1
	print "----------------"
	print csum

main()
	
